import {
  Ref,
  Component,
  PropType,
  SetupContext,
  ComponentInternalInstance,
  EmitsOptions,
  WatchStopHandle,
} from "vue";

import { Editor, EditorConfiguration } from "codemirror";

export type {
  Editor,
  EditorConfiguration,
  Ref,
  Component,
  PropType,
  SetupContext,
  ComponentInternalInstance,
  EmitsOptions,
  WatchStopHandle,
};
declare var Codemirror: any;
export default Codemirror;
export { Codemirror };
export * from "./src/presetMode/log/utils";
declare global {
  interface Window {
    diff_match_patch: any;
    DIFF_DELETE: number;
    DIFF_INSERT: number;
    DIFF_EQUAL: number;
  }
  type Nullable<T> = T | null;
}

export declare interface CmProps {
  value: string;
  marker?: () => HTMLElement;
  unseenLines: Array<any>;
  name?: string;
  placeholder?: string;
  merge?: boolean;
  options?: EditorConfiguration;
  globalOptions?: EditorConfiguration;
  border?: boolean;
  width: string | number;
  height: string | number;
  KeepCursorInEnd: boolean;
}

export interface ComponentsEvts {
  "update:value": (value: string) => value;
  change: (value: string, cm: Editor) => { value; cm };
  input: (value: string) => value;
  ready: (cm: Editor) => cm;
  [key: string]: any;
}
declare module "codemirror";
